<template>
  <section id="SpaceBodies">
    <h2>Space bodies</h2>
    <div class="tops">
      <Top
        title="Largest objects in the solar system"
        :top="tenLargest"
        comment="Honorable mention : your mom"
      />
      <Top
        title="Smallest objects in the solar system"
        :top="tenSmallest"
        comment="Number 6 will surprise you"
      />
      <Top
        title="Best moons to live on in the Solar system"
        :top="bestMoons"
        comment="Io, hands down"
      />
    </div>
  </section>
</template>

<script>
import Top from "./Top.vue";

export default {
  name: "SpaceBodies",
  components: {
    Top
  },
  data() {
    return {
      tenLargest: null,
      tenSmallest: null,
      bestMoons: null
    };
  },
  created() {
    /**
     * Store moons
     */
    if (!this.$store.getters.bestMoons) {
      this.$store.commit(
        "setBestMoons",
        this.$store.getters.allData.bodies
          .filter(elem => !elem.isPlanet)
          .filter(elem => elem.gravity >= 1)
          .sort((a, b) => {
            return a.gravity - b.gravity;
          })
          .slice(0, 10)
      );
    }

    /**
     * Store 10 largest objects in the solar system
     */
    if (!this.$store.getters.largestObjects) {
      this.$store.commit(
        "setLargestObjects",
        this.$store.getters.allData.bodies
          .sort((a, b) => {
            return a.meanRadius + b.meanRadius;
          })
          .slice(0, 10)
      );
    }

    /**
     * Store 10 smallest objects in the solar system
     */
    if (!this.$store.getters.smallestObjects) {
      this.$store.commit(
        "setSmallestObjects",
        this.$store.getters.allData.bodies
          .sort((a, b) => {
            return a.meanRadius - b.meanRadius;
          })
          .slice(0, 10)
      );
    }
    // Hydrate component data

    this.tenLargest = this.$store.getters.largestObjects;
    this.tenSmallest = this.$store.getters.smallestObjects;
    this.bestMoons = this.$store.getters.bestMoons;
  }
};
</script>

<style scoped lang="scss">
#SpaceBodies {
  display: flex;
  flex-direction: column;

  .tops {
    display: flex;
    /* Large devices (laptops/desktops, 992px and up) */
    justify-content: space-evenly;

    @media only screen and (max-width: 700px) {
      flex-direction: column;
    }
  }
}
</style>